local addon = LibStub("AceAddon-3.0"):NewAddon("BindVehicle")

-- "Sunreaver Hawkstrider" 62544:62575:62960:62552:64077:62863:0:0:0:0

local defaults = {
	profile = {
		bindings = {
			["62544:62575:62960:62552:64077:62863:0:0:0:0"] = "E:R:F:Q::::::",
		},
	},
}

function addon:OnInitialize()
	self.db = LibStub("AceDB-3.0"):New("BindVehicleDB", defaults)
	self.db.RegisterCallback(self, "OnProfileChanged", "ProfileUpdate")
	self.db.RegisterCallback(self, "OnProfileCopied", "ProfileUpdate")
	self.db.RegisterCallback(self, "OnProfileReset", "ProfileUpdate")
	
	self.stateHandler = CreateFrame("Frame", nil, UIParent, "SecureHandlerStateTemplate")
	self.stateHandler:Execute([[
		bindings = newtable()
	]])
	self:ProfileUpdate()
	self.stateHandler:SetAttribute("_onstate-vehicle", [=[
		self:ClearBindings()
		if newstate == "vehicle" then
			local sig = ""
			for a=121,130 do
				if sig ~= "" then
					sig = sig .. ":"
				end
				sig = sig .. select(4, GetActionInfo(a))
			end
			if bindings[sig] then
				control:Run([[
					for i=1,select('#', ...) do
						local key = select(i, ...)
						if key ~= "" then
							self:SetBinding(true, key, ("BONUSACTIONBUTTON%d"):format(i))
						end
					end
				]], string.split(":", bindings[sig]))
			end
		end
	]=])
	RegisterStateDriver(self.stateHandler, "vehicle", "[bonusbar:5]vehicle;novehicle")
end

function addon:ProfileUpdate()
	-- wipe and regenerate the restricted table on every profile update
	self.stateHandler:Execute([[
		table.wipe(bindings)
	]])
	for k,v in pairs(self.db.profile.bindings) do
		if select('#', string.split(":", k)) == 10 and select('#', string.split(":", v)) == 10 then -- just some sanity checking
			self.stateHandler:Execute(([[
				bindings[%q] = %q
			]]):format(k,v))
		end
	end
end
